/**
 * Author: Sergey Kopeliovich (Burunduk30@gmail.com)
 * Date: 2015.03.19
 */

#include <bits/stdc++.h>

using namespace std;

#define forn(i, n) for (int i = 0; i < (int)(n); i++)

const int maxN = 1e4;
const int maxE = 1e5;

int na, nb, ne, pa[maxN], color[maxN];
int e, head[maxN], Next[maxE], to[maxE];
int cc, used[maxN];
int rn, r[maxN];
int cnt = 0;

int dfs( int v ) {
  int x;
  used[v] = cc, cnt++;
  for (int e = head[v]; e != -1; e = Next[e], cnt++)
    if (pa[x = to[e]] == -1 || (used[pa[x]] != cc && dfs(pa[x]))) {
      pa[x] = v, color[v] = 1;
      return 1;
    }
  return 0;
}

template <class T = int> 
inline T readInt();    
inline bool seekEof();

template <class T> 
inline void writeInt( T x );
inline void writeWord( const char *s );
inline void flush();

void Out() {
  writeWord("Managers "), writeInt(r[0] + 1);
  for (int i = 1; i + 1 < rn; i++) 
    writeWord(", "), writeInt(r[i] + 1);
  writeWord(" and ");
  writeInt(r[rn - 1] + 1);
  writeWord(" form an excessive subset.\n");
}

int main() {
  #define NAME "sociology"
  assert(freopen(NAME ".in", "r", stdin));
  assert(freopen(NAME ".out", "w", stdout));

  int tn = 0;
  while (!seekEof()) {
    writeWord("Case #");
    writeInt(++tn);
    writeWord(": ");
    rn = 0;

    //fprintf(stderr, "Case #%d: read data...\n", tn);
    nb = readInt();
    na = readInt();
    ne = readInt();
    memset(head, -1, sizeof(head));
    e = 0;
    while (ne--) {
      int b = readInt() - 1;
      int a = readInt() - 1;
      Next[e] = head[a], to[e] = b, head[a] = e++;
    }

    if (na > nb) {
      forn(i, na)
        r[rn++] = i;
      Out();
      continue;
    }
  
    int bad = 0;
    forn(i, na)
      if (head[i] == -1) {
        writeWord("Manager ");
        writeInt(i + 1);
        writeWord(" forms an excessive subset.\n");
        bad = 1, i = na;
      }
    if (bad)
      continue;

    //fprintf(stderr, "Case #%d: find matching\n", tn);
    int ans = 0;
    memset(pa, -1, sizeof(pa));
    memset(color, 0, sizeof(color));
    forn(i, na)
      for (int e = head[i]; e != -1; e = Next[e])
        if (pa[to[e]] == -1) {
          pa[to[e]] = i, color[i] = 1, ans++;
          break;
        }
    cc++;
    for (int run = 1; !bad && run; ) {
      run = 0, cc++;
      forn(i, na)
        if (!color[i] && used[i] != cc) {
          if (dfs(i))
            run = 1, ans++;
          else if (!run) {
            bad = 1;
            break;
          }
        }
    }

    if (ans == na)
      writeWord("There is no excessive subset of managers.\n");
    else {
      forn(i, na)
        if (used[i] == cc)
          r[rn++] = i;
      Out();
    }
  }
  fprintf(stderr, "time = %.2f\n", (double)clock() / CLOCKS_PER_SEC);
  fprintf(stderr, "cnt  = %d\n", cnt);
  flush();
  return 0;
}

/** Read */

static const int buf_size = 4096;

static char __buf[buf_size];
static int __len = 0, __pos = 0;

inline bool isEof() {
  if (__pos == __len) {
    __pos = 0, __len = fread(__buf, 1, buf_size, stdin);
    if (__pos == __len)
      return 1;
  }
  return 0;
}

inline int getchar_fast() { // you may use getchar() instead of it
  return isEof() ? -1 : __buf[__pos++];
}

inline int peekChar() { 
  return isEof() ? -1 : __buf[__pos];
}

inline bool seekEof() { 
  int c;
  while ((c = peekChar()) != -1 && c <= 32)
    __pos++;
  return c == -1;
}

inline int readChar() {
  int c = getchar_fast();
  while (c != -1 && c <= 32)
    c = getchar_fast();
  return c;
}

template <class T>
inline T readInt() {
  int s = 1, c = readChar();
  T x = 0;
  if (c == '-')
    s = -1, c = getchar_fast();
  while ('0' <= c && c <= '9')
    x = x * 10 + c - '0', c = getchar_fast();
  return s == 1 ? x : -x;
}

/** Write */

static int write_pos = 0;
static char write_buf[buf_size];

inline void writeChar( int x ) {
  if (write_pos == buf_size)
    fwrite(write_buf, 1, buf_size, stdout), write_pos = 0;
  write_buf[write_pos++] = x;
}

inline void flush() {
  if (write_pos)
    fwrite(write_buf, 1, write_pos, stdout), write_pos = 0;
}

template <class T> 
inline void writeInt( T x ) {
  if (x < 0)
    writeChar('-'), x = -x;

  char s[24];
  int n = 0;
  while (x || !n)
    s[n++] = '0' + x % 10, x /= 10;
  while (n--)
    writeChar(s[n]);
}

inline void writeWord( const char *s ) {
  while (*s)
    writeChar(*s++);
}
